function QT.events.OnEvent( event, ... )
	if( event == "VARIABLES_LOADED" )then
		QT.events.VariablesLoaded();
	end;
	if( event == "ADDNEW_QUESTBOOK" )or( event == "RESET_QUESTBOOK" )or( event == "QUEST_COMPLETE" )then
		QT.tools.GrabQuestsInfo();
		QT.ui.TrackerOnShow();
		QuestTrackerFrame:Hide();
		TheQuestTrackerBar:Hide();
	end;
	if( event == "RESET_QUESTTRACK" )then
		QT.tools.UpdateQuestsInfo();
		QT.ui.TrackerOnShow();
		QuestTrackerFrame:Hide();
		TheQuestTrackerBar:Hide();
	end;
end;

function QT.events.OnShow( this )
	QTMinimapButtonTitle:SetText( QT.Name );
end;

function QT.events.VariablesLoaded()
	if( type( mQuestTrackerVariables ) ~= "table" )then
		mQuestTrackerVariables = QT.DefaultConfig;
		QT.Message( 'First start! Set default config values.' );
	else
		for k, v in pairs( QT.DefaultConfig ) do
			if( mQuestTrackerVariables[k] == nil ) then mQuestTrackerVariables[k] = v; end;
		end;
	end;
	SaveVariables( "mQuestTrackerVariables" );
	
	-- Информация о квестах
	QT.tools.GrabQuestsInfo();
	
	QT.Message( QT.Name .. " " .. QT.Version .. " успешно загружен." );
	QT.Message( string.format( "Принято %d квестов", QT.Vars.QuestsCount ) );
	QT.Message( string.format( "Из них отслеживается %d", QT.Vars.QuestsView ) );
	
	QT.ui.TrackerOnShow();
	if( not mQuestTrackerVariables.Visible )then QT.ui.ShowHideTracker(); end;
	QuestTrackerFrame:Hide();
	TheQuestTrackerBar:Hide();
end;

function QT.events.NewQuestNameOnUpdate( this, elapsedTime )
	if( QT.Vars.Shower )then
		QT.ui.ResizeQuestShower( 25 + QT.Vars.ShowStep * 3 );
		QTNewQuestNameTitle:SetAlpha( 1 - ( QT.Vars.ShowStep / QT.Vars.StepsCount ) );
		QT.Vars.ShowStep = QT.Vars.ShowStep + 1;
		
		if( QT.Vars.ShowStep > QT.Vars.StepsCount )then QT.Vars.Shower = false; end;
	end;
end;

--[[ /run dofile("Interface/AddOns/mQuestTracker/code/event.lua"); ]]