QT.ui.Vars = {
	["ShowUntracked"] = "Показывать неотмечаемые",
	["PlaySound"] = "Звук при выполнении",
	["ExtraQuestBook"] = "Изменить вид книги",
	["NewQuestShow"] = "Показывать новый квест",
};

function QT.ui.ShowHint(this)
	GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
	GameTooltip:SetText( QT.Name .. " " .. QT.Version, 1, 1, 1 );
	GameTooltip:AddSeparator();
	if( mQuestTrackerVariables.ShowUntracked )then
		GameTooltip:AddLine( "  " .. QT.ui.Vars.ShowUntracked .. ": " .. QT.YESPattern:format( "Да" ) );
	else
		GameTooltip:AddLine( "  " .. QT.ui.Vars.ShowUntracked .. ": " .. QT.NOPattern:format( "Нет" ) );
	end;

	if( mQuestTrackerVariables.PlaySound )then
		GameTooltip:AddLine( "  " .. QT.ui.Vars.PlaySound .. ": " .. QT.YESPattern:format( "Да" ) );
	else
		GameTooltip:AddLine( "  " .. QT.ui.Vars.PlaySound .. ": " .. QT.NOPattern:format( "Нет" ) );
	end;

	if( mQuestTrackerVariables.ExtraQuestBook )then
		GameTooltip:AddLine( "  " .. QT.ui.Vars.ExtraQuestBook .. ": " .. QT.YESPattern:format( "Да" ) );
	else
		GameTooltip:AddLine( "  " .. QT.ui.Vars.ExtraQuestBook .. ": " .. QT.NOPattern:format( "Нет" ) );
	end;

	if( mQuestTrackerVariables.NewQuestShow )then
		GameTooltip:AddLine( "  " .. QT.ui.Vars.NewQuestShow .. ": " .. QT.YESPattern:format( "Да" ) );
	else
		GameTooltip:AddLine( "  " .. QT.ui.Vars.NewQuestShow .. ": " .. QT.NOPattern:format( "Нет" ) );
	end;

	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );

	GameTooltip:AddLine( "Левая кнопка мыши скрыть/показать трекер", 0, 0.75, 0.95 );
	GameTooltip:AddLine( "Правая кнопка мыши для вызова меню настроек", 0, 0.75, 0.95 );
	GameTooltip:AddLine( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
	GameTooltip:Show();
end;

function QT.ui.HideHint()
	GameTooltip:Hide();
end;

function QT.ui.ColorizeText( text, _type, lv )
	local stColors = {
		[1] = "|cffFFFFFF%s|r", -- обычный квест
		[2] = "|cff1695C4%s|r", -- дейлик
		[3] = "|cffE10A95%s|r", -- мероприятие
		[4] = "|cff009900%s|r", -- завершенное
		[5] = "|cffFF66FF%s|r", -- эпос
	};
	local stByLevel = {
		[1] = "|cffFF0000[%s]|r",
		[2] = "|cff00B200[%s]|r",
		[3] = "|cffFFFF00[%s]|r",
	};
	local oLv = GetCurrentVocLV() - lv;
	local lvID = 3;
	if( oLv <= -3 )then
		lvID = 1;
	elseif( oLv >= 3 )then
		lvID = 2;
	else
		lvID = 3;
	end;
	return string.format( stByLevel[ lvID ], lv ) .. " " .. string.format( stColors[ _type ], text );
end;

function QT.ui.ThSeparator( str )
	local formatted = str;
	while true do
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1' .. "." .. '%2');
		if (k == 0) then
			break;
		end;
	end;
	return formatted;
end;

function QT.ui.TrackerOnShow()
	QTMinimapButtonTitle:SetText( QT.Name .. " (" .. QT.Vars.QuestsView .. "/" .. QT.Vars.QuestsCount .. ")" );
	local qID = 1;
	for n = 1, 30 do
		for i = 1, 10 do
			_G[ "QTFrameQuest" .. n .. "String" .. i ]:SetText("");
			if( _G[ "QTFrameQuest" .. tonumber( n + 1 ) ] ~= nil )then
				_G[ "QTFrameQuest" .. tonumber( n + 1 ) .. "String" .. i ]:SetText("");
				_G[ "QTFrameQuest" .. tonumber( n + 1 ) ]:ClearAllAnchors();
				_G[ "QTFrameQuest" .. tonumber( n + 1 ) ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "QTFrameQuest" .. n ], 0, 0 );
			end;
		end;
		_G[ "QTFrameQuest" .. n .. "Text" ]:SetText("");
		_G[ "QTFrameQuest" .. n ]:Hide();
		_G[ "QTFrameQuest" .. n .. "Hide" ]:Hide();
	end;
	for n = 1, QT.Vars.QuestsCount do
		if( ( QT.QuestBook[ n ]["track"] == 2 )or( ( QT.QuestBook[ n ]["track"] == 0 )and( mQuestTrackerVariables.ShowUntracked ) ) )and( qID <= 20 )then
			local _type = 1;
			if( QT.QuestBook[ n ]["daily"] )then  _type = 2;  end;
			if( QT.QuestBook[ n ]["iQuestGroup"] == 3 )then  _type = 3;  end;
			if( QT.QuestBook[ n ]["completed"] )then  _type = 4;  end;
			_CatalogID = QT.QuestBook[ n ]["catalogID"];
			if( _CatalogID == 102 or _CatalogID == 133 or _CatalogID == 199 or _CatalogID == 200 or _CatalogID == 211 )then  _type = 5;  end;

			_G[ "QTFrameQuest" .. qID .. "Text" ]:SetText( QT.ui.ColorizeText( QT.QuestBook[ n ]["name"], _type, QT.QuestBook[ n ]["level"] ) );
			_G[ "QTFrameQuest" .. qID ]:SetID( n );
			_G[ "QTFrameQuest" .. qID ]:Show();
			if( QT.QuestBook[ n ]["track"] == 2 )then _G[ "QTFrameQuest" .. qID .. "Hide" ]:Show(); end;

			local NumRequest = GetQuestRequest( n, -1 ); 
			if( not NumRequest )then
			else
				for i = 1, NumRequest do
					if( _G[ "QTFrameQuest" .. tonumber( qID + 1 ) ] ~= nil )then
						_G[ "QTFrameQuest" .. tonumber( qID + 1 ) ]:ClearAllAnchors();
						_G[ "QTFrameQuest" .. tonumber( qID + 1 ) ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", _G[ "QTFrameQuest" .. qID ], 0, i * 12 );
					end;
					local Text, IsFinish = GetQuestRequest( n, i );
					Text = QT.ui.ColorizeRequest( Text, IsFinish );
					if( QT.Sounds[ n ] == nil )then QT.Sounds[ n ] = {}; end;
					if( IsFinish == 1 )then Text = Text .. " |cff00FF00(Завершено)|r"; end;
					if( IsFinish == 1 )and( QT.Sounds[ n ][ i ] == nil )then 
						QT.Sounds[ n ][ i ] = true;
						if( mQuestTrackerVariables.PlaySound )then PlaySoundByPath("sound\\interface\\QuestItemFinish.mp3"); end;
					end;
					_G[ "QTFrameQuest" .. qID .. "String" .. i ]:SetText( Text );
				end;
				
			end;
			
			qID = qID + 1;
		end;
	end;
end;

function QT.ui.ShowQuestInBook( this )
	local questID = this:GetID();
end;

function QT.ui.ColorizeRequest( qRequestLine, IsFinish )
	local p, r, q = string.match( qRequestLine, "(.+) (%d+)/(%d+)\n?" );
	local newQuestMsg = "";
	if( q == nil )then
		local p = string.match( qRequestLine, "(.+) %(завершено%)\n?" );
		if( p ~= nil )then 
			if( IsFinish == 1 )then
				newQuestMsg = newQuestMsg .. MLib.PercentFormat( 100, p );
			else
				newQuestMsg = newQuestMsg .. p;
			end;
		else
			if( IsFinish == 1 )then
				newQuestMsg = newQuestMsg .. MLib.PercentFormat( 100, qRequestLine );
			else
				newQuestMsg = newQuestMsg .. qRequestLine;
			end;
		end;
		return newQuestMsg;
	end;
	r = tonumber( r );
	q = tonumber( q );
	if( r >= q )then
		newQuestMsg = newQuestMsg .. MLib.PercentFormat( 100, p );
	else
		newQuestMsg = newQuestMsg .. p;
	end;
	newQuestMsg = newQuestMsg .. " " .. MLib.PercentFormat( math.floor( r * 100 / q ), r ) .. "/" .. MLib.PercentFormat( 100, q );
	return newQuestMsg;
end;

function QT.ui.ShowQuestHint( this )
	local questID = this:GetID();
	
	GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
	GameTooltip:SetText( QT.QuestBook[ questID ]["name"], 1, 1, 1 );
	
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );

	local NumRequest = GetQuestRequest( questID, -1 ); 
	if( QT.QuestBook[ questID ]["completed"] )then
		GameTooltip:AddLine( "|cff009900Завершено!|r" );
	else
		if( not NumRequest )then
		else
			GameTooltip:AddLine( "Цели: " );
			for n = 1, NumRequest do
				local Text, IsFinish = GetQuestRequest( questID, n );
				QT.ui.ColorizeRequest(Text);
				Text = QT.ui.ColorizeRequest( Text, IsFinish );
				if( IsFinish == 1 )then Text = Text .. " |cff00FF00(Завершено)|r"; end;
				GameTooltip:AddLine( " " .. Text );
			end;
			
		end;
	end;

	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );
	GameTooltip:AddLine( "" );

	GameTooltip:AddLine( QUESTBOOK_QUESTREWARD_EXP .. "+" .. QT.ui.ThSeparator( QT.QuestBook[ questID ]["exp"] ) );
	GameTooltip:AddLine( QUESTBOOK_QUESTREWARD_TP .. "+" .. QT.ui.ThSeparator( QT.QuestBook[ questID ]["tp"] ) );
	GameTooltip:AddLine( UI_QuestBook_QuestReward_MoneyTitle:GetText() .. " " .. QT.ui.ThSeparator( QT.QuestBook[ questID ]["money"] ) );
	
	GameTooltip:AddSeparator();
	if( IsShiftKeyDown() )then
		GameTooltip:AddLine( QT.QuestBook[ questID ]["details"] );
	else
		GameTooltip:AddLine( QT.QuestBook[ questID ]["description"] );
		GameTooltip:AddLine( "" );
		GameTooltip:AddLine( "" );
		GameTooltip:AddLine( "" );
		GameTooltip:AddLine( "Наведите с нажатой клавишей Shift, чтобы посмотреть детали квеста" );
	end;
	
	GameTooltip:Show();
end;

function QT.ui.ShowHideTracker()
	if( QTFrameScrollFrame:IsVisible() )then
		QTMinimapButtonTitle:SetText( "" );
		QTFrameScrollFrame:Hide();
	else
		QTMinimapButtonTitle:SetText( QT.Name );
		QT.ui.TrackerOnShow();
		QTFrameScrollFrame:Show();
	end;
	mQuestTrackerVariables.Visible = QTFrameScrollFrame:IsVisible();
end;

function QT.ui.ClickQuest( this )
	if( string.sub( this:GetName(), 1, 12 ) ~= "QTFrameQuest" )then return nil; end;
	local questID = this:GetID();
	
	ShowUIPanel( UI_QuestBook );
	ViewQuest_QuestBook( questID );
end;

function QT.ui.SetQuestTrack( id )
	SetQuestTrack( id );
end;

function QT.ui.OptionsMenu( this )
	local info = {}
	if UIDROPDOWNMENU_MENU_LEVEL == 1 then
		info = {}
		info.text = QT.ui.Vars.ShowUntracked
		info.checked = mQuestTrackerVariables.ShowUntracked
		info.func = function() mQuestTrackerVariables.ShowUntracked = not mQuestTrackerVariables.ShowUntracked; QT.ui.TrackerOnShow(); end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = QT.ui.Vars.PlaySound
		info.checked = mQuestTrackerVariables.PlaySound
		info.func = function() mQuestTrackerVariables.PlaySound = not mQuestTrackerVariables.PlaySound; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = QT.ui.Vars.ExtraQuestBook
		info.checked = mQuestTrackerVariables.ExtraQuestBook
		info.func = function() mQuestTrackerVariables.ExtraQuestBook = not mQuestTrackerVariables.ExtraQuestBook; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = QT.ui.Vars.NewQuestShow
		info.checked = mQuestTrackerVariables.NewQuestShow
		info.func = function() mQuestTrackerVariables.NewQuestShow = not mQuestTrackerVariables.NewQuestShow; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)
	end;
end;

function QT.ui.ShowNewQuest( questName )
	QTNewQuestNameTitle:SetText( questName );
	
	QT.ui.ResizeQuestShower( 25 );
	QTNewQuestNameTitle:SetAlpha( 1.0 );
	QT.Vars.Shower = true;
	QT.Vars.ShowStep = 1;
	
	QTNewQuestName:Show();
end;

function QT.ui.ResizeQuestShower( fontSize )
	QTNewQuestNameTitle:SetFontSize( fontSize );
	local text = QTNewQuestNameTitle:GetText();
	QTNewQuestNameTitle:SetText( "" );
	QTNewQuestNameTitle:SetText( text );
end;

--QTNewQuestName
--[[ /run dofile("Interface/AddOns/mQuestTracker/code/ui.lua"); ]]